#pragma once
#include "actiondep.h"
#include "merrors.h"

using michlib::message;
using michlib::Error;

template<class T>
concept MirrorSupported = requires(T t, const CLArgs& args) {
 {
  t.Mirror(args)
 } -> std::convertible_to<Error>;
};

ADD_ACTION(Mirror, mirror, MirrorSupported<Source>);

template<class D> MString ActionMirror::DoAction(const CLArgs& args, D& data)
{
 auto res = data.Mirror(args);
 if(!res) return "Mirroring failed";
 return "";
};
