#pragma once
#include "DataAdapters/ncfilealt.h"
#include "ParseArgs.h"
#include "simple2ddata.h"

class TSCDATAData
{
 michlib::NCFileA     nc;
 std::vector<MString> vnames, lnames;
 size_t               nx, ny;
 MString              history;

 using DataType = float;

 public:
 static constexpr const char* name = "TSCDATA";

 MString Info() const;
 MString Open(const CLArgs& args);

 std::vector<DataType> ReadLons() const;
 std::vector<DataType> ReadLats() const;
 std::vector<DataType> ReadVar(const MString& name) const;

 const auto& VarNames() const { return vnames; }
 const auto& LongNames() const { return lnames; }

 size_t Nx() const { return nx; }
 size_t Ny() const { return ny; }
 size_t NVar() const { return vnames.size(); }

 const auto& History() const { return history; }

 DataType FillVal(const MString& name) const;
};
