#define MICHLIB_NOSOURCE
#include "curlfuncs.h"
#include <unistd.h>

using michlib::pointer_cast;
using michlib::uint1;

size_t Write2String(char* ptr, size_t size, size_t n, void* data)
{
 MString* out = pointer_cast<MString*>(data);
 *out += MString(ptr, size * n);
 return size * n;
}

size_t Write2File(char* ptr, size_t size, size_t n, void* data)
{
 const int*   fd    = pointer_cast<const int*>(data);
 size_t       count = size * n;
 const uint1* buf   = pointer_cast<const uint1*>(ptr);

 while(count != 0)
 {
  auto wr = write(*fd, buf, count);
  if(wr == -1) return 0;
  count -= wr;
  buf += wr;
 }

 return size * n;
}

std::pair<MString, CURLcode> GetUrl(const CURLRAII& chandle, const MString& url)
{
 MString out;

 curl_easy_setopt(chandle, CURLOPT_URL, url.Buf());
 curl_easy_setopt(chandle, CURLOPT_WRITEFUNCTION, Write2String);
 curl_easy_setopt(chandle, CURLOPT_WRITEDATA, &out);
 auto res = curl_easy_perform(chandle);
 return {out, res};
}
